Attribute VB_Name = "mdlBubuX"
' BubuX's algo

' Autor comments:
   ' I've been working on it for an hour and here I am.
   ' The code is limited to convert numbers up to 1999
   ' (that is "MDCMXCIX"). I'll limit it to higher as soon
   ' as I have one question answered.
   ' There is something to be fixed yet: there must be declared
   ' some global variables and the sub InitializeRomanConstants()
   ' need to be called ONCE before using the GetDec() function.
   ' Reason: InitializeRomanConstants() loads an aray of constants
   ' (the global variables).

Private RomanNum, RomanDec, RomanHund, NumEquiv

' I = 1
' V = 5
' X = 10
' L = 50
' C = 100
' D = 500
' M = 1000

Public Sub InitializeRomanConstants()
   RomanNum = Array("IX", "VIII", "VII", "VI", "IV", "V", "III", "II", "I")
   RomanDec = Array("XC", "LXXX", "LXX", "LX", "XL", "L", "XXX", "XX", "X")
   RomanHund = Array("CM", "DCCC", "DCC", "DC", "CD", "D", "CCC", "CC", "C")
   NumEquiv = Array(9, 8, 7, 6, 4, 5, 3, 2, 1)
End Sub

Public Function GetDec(ByVal RomanNumber As String) As Long

   Dim I As Long, TmpString As String

   TmpString = UCase(Trim(RomanNumber))
   
   For I = 0 To 8
      If InStr(1, TmpString, RomanNum(I), vbTextCompare) > 0 Then _
         GetDec = GetDec + (NumEquiv(I) * 1): Exit For
   Next

   For I = 0 To 8
      If InStr(1, TmpString, RomanDec(I), vbTextCompare) > 0 Then _
         GetDec = GetDec + (NumEquiv(I) * 10): Exit For
   Next

   For I = 0 To 8
      If InStr(1, TmpString, RomanHund(I), vbTextCompare) > 0 Then _
         GetDec = GetDec + (NumEquiv(I) * 100): Exit For
   Next

   If InStr(1, TmpString, "M", vbTextCompare) > 0 Then GetDec = GetDec + 1000

End Function
